% prueba la rutina de captura de puntos de agarre de entrenamiento

% modificado para que muestre solo imagenes de agarres factibles
function [x, y, xc, yc] = carga_figura_imagenes(num_fig);
   
switch num_fig
case 1
    ejemplo = 'bandera';
    escala = 1.5;
case 2
    ejemplo = 'trapecio';
    escala = 1;
case 3
    ejemplo = 'cilindro';
    escala = 1;
case 4
    ejemplo = 'coche';
    escala = 0.9;
case 5
    ejemplo = 'rugby';
    escala = 1.0;
case 6
    ejemplo = 'estrella';
    escala = 1.3;
case 7
    ejemplo = 'flecha1';
    escala = 1.3;
case 8
    ejemplo = 'flecha2';
    escala = 1.3;
case 9
    ejemplo = 'flecha3';
    escala = 1.3;
case 10
    ejemplo = 'hexagono';
    escala = 1.3;
case 11
    ejemplo = 'iman';
    escala = 1.5;
case 12
    ejemplo = 'luna';
    escala = 1.3;
case 13
    ejemplo = 'monigote';
    escala = 1.6;
case 14
    ejemplo = 'octogono';
    escala = 1.2;
case 15
    ejemplo = 'pelota';
    escala = 2;
case 16
    ejemplo = 'pentagono';
    escala = 1.2;
case 17
    ejemplo = 'rombo';
    escala = 1.0;
case 18
    ejemplo = 'placa';
    escala = 1.2;
case 19
    ejemplo = 'rayo';
    escala = 1.6;
case 20
    ejemplo = 'pesas';
    escala = 1.8;
case 21
    ejemplo = 'destornillador';
    escala = 1.8;
case 22
    ejemplo = 'sacacorchos';
    escala = 1.8;
case 23
    ejemplo = 'sarten';
    escala= 2.2;
case 24
    ejemplo = 'botella';
    escala = 1.6;
end

% fprintf(1, '\nfigura elegida: %s\n\n', ejemplo);

% carga puntos x e y del contorno
fichero = sprintf('dibujos/%s', ejemplo);
load (fichero);

% carga puntos x e y del centroide de la figura
fichero = sprintf('dibujos/%s.cent', ejemplo);
file = fopen(fichero, 'r');
[cent, n] = fscanf(file, '%f');
fclose(file);
xc = cent(1);
yc = cent(2);
   
% escala los datos en el eje x y la componente x del centroide
% busca un tamao adecuado para que existan varias posibilidades de agarre
x = x.*escala;
xc = xc*escala;
% x = x./400; % adapta a tamao entre 0 y 1
% xc = xc/400;
maxi = max(x);
mini = min(x);
centro = (maxi+mini)/2;
% x = x + (0.5-centro); % centra en la figura
% xc = xc + (0.5-centro);
x = x + (200-centro); % centra en la figura
xc = xc + (200-centro);
    
% escala los datos en el eje y y la componente y del centroide
% busca un tamao adecuado para que existan varias posibilidades de agarre
y = y.*escala;
yc = yc*escala;
% y = y./400; % adapta a tamao entre 0 y 1
% yc = yc/400;
maxi = max(y);
mini = min(y);
centro = (maxi+mini)/2;
% y = y + (0.5-centro); % centra en la figura
% yc = yc + (0.5-centro);
y = y + (200-centro); % centra en la figura
yc = yc + (200-centro);
    
return
