% calcula los datos de un punto de agarre
function [dist, angulo] = datospunto(x, y, xc, yc, pto);

% numero de puntos del contorno
nptos = length(x);

% distancia del punto al centro de gravedad (al cuadrado)
dist = (x(pto)-xc)^2 + (y(pto)-yc)^2;

% angulo girado por el contorno en ese punto (resoluciones 5, 10, 15, 20, 30)
resol = [5 10 15 20 30];

for i=1:5
   
   % resoluciones prefijadas
   j=resol(i);
   
 	% calculo del punto j elementos anterior al estudiado
   ant = pto-j;
   if ant<1
      ant = nptos+ant;
   end
      
   % calculo del punto j elementos posterior al estudiado
   pos = pto+j;
   if pos>nptos
      pos = pos-nptos;
   end
      
   % expresion de los 3 puntos en terminos incrementales
   [incx, incy] = incrementos([x(ant), x(pto), x(pos)],[y(ant), y(pto), y(pos)]);
      
   % calculo de angulos para cada segmento
   ang = cod_cadena(incx,incy);
      
   % calculo de incrementos angulares
   difang = dif_cadena(ang);
      
   % el dato buscado es el primero de los incrementos devueltos
   angulo(i) = difang(1);
            
end
   

   

