% calcula el punto de referencia (centroide del espacio conexo definido por los puntos de contacto)
function [refx, refy] = ptoreferencia(x, y, cont, pto, num_dedos)

if num_dedos==2
    
    % en caso de haber unicamente dos dedos, es el punto medio
    refx = (x{cont(1)}(pto(1))+x{cont(2)}(pto(2)))/2;
    refy = (y{cont(1)}(pto(1))+y{cont(2)}(pto(2)))/2;
    
elseif num_dedos==3
    
    % en caso de haber tres dedos, es el baricentro del triangulo formado
    [refx, refy] = baricentro(x, y, cont, pto);

else
    
    % de forma generica se podria utilizar la funcion imfeature de Matlab que permite calcular
    % el centroide de cualquier imagen, pero por ahora no se considera el caso de pinzas
    % con mas de tres dedos
    refx = inf;
    refy = inf;
    
end
    
   
