% rechaza combinaciones no alcanzables detectables trivialmente para una pinza de dos dedos
function [conjok3, num_ok3] = rechaza_trivial2(conj, num_conj, x, y, lim_max, lim_min)

% contorno y punto de cada elemento del vector unin de todos los contornos
ind = 0;
for i=1:length(x)
    for k=1:length(x{i})
        ind = ind+1;
        c(ind)=i;
        p(ind)=k;
    end
end
numtotal = ind;

% primera prueba: acotacion distancias entre dedos
%-------------------------------------------------

num_ok1=0;

for i=1:num_conj
    
    % calcula distancias entre los dedos (al cuadrado)
    c1 = c(conj(i,1));
    c2 = c(conj(i,2));
    p1 = p(conj(i,1));
    p2 = p(conj(i,2));
    dist = (x{c1}(p1)-x{c2}(p2))^2+(y{c1}(p1)-y{c2}(p2))^2;
       
    if dist<lim_max & dist>lim_min
        
        num_ok1 = num_ok1+1;
        conjok1(num_ok1, 1)=conj(i,1);
        conjok1(num_ok1, 2)=conj(i,2);

    end
    
end


% segunda prueba: normales a la superficie del objeto no paralelas (min. 90 de separacion)
%------------------------------------------------------------------------------------------

% calcula las normales en cada uno de los puntos del contorno
% se toma resolucion fija = separacion de 7 puntos
% (vector que va desde 3 puntos antes hasta 3 puntos despues del punto donde se desea calcular el angulo)

ind = 0;
for i=1:length(x)
    ptoscont = length(x{i});
    for k=1:ptoscont
        ind = ind+1;
        ant = k-3;
        if ant<1
            ant = ptoscont+ant;
        end
        post = k+3;
        if post>ptoscont
            post = post-ptoscont;
        end
        
        rectax = x{i}(post)-x{i}(ant);
        rectay = y{i}(post)-y{i}(ant);
        angulo(ind) = cod_cadena(rectax, rectay)+90;
        if angulo(ind)>180
            angulo(ind)=angulo(ind)-360;
        end
        
    end
end
        
%plot(angulo);

% debe haber al menos pi/4 de separacion entre los angulos
num_ok2=0;

for i=1:num_ok1
    
    ang(1)=angulo(conjok1(i,1));
    ang(2)=angulo(conjok1(i,2));
    
    difer = min([abs(ang(1)-ang(2)), abs(360+ang(1)-ang(2))]);
    
    if difer>90
        
        num_ok2 = num_ok2+1;
        conjok2(num_ok2, 1)=conjok1(i,1);
        conjok2(num_ok2, 2)=conjok1(i,2);
        
    end
    
end


% tercera prueba: a partir de las normales a la superficie del objeto se detectan colisiones
%-------------------------------------------------------------------------------------------

num_ok3 = 0;

for i=1:num_ok2
    
    % contornos y puntos en el vector unin de todos los contornos
    c1 = c(conjok2(i,1));
    c2 = c(conjok2(i,2));
    p1 = p(conjok2(i,1));
    p2 = p(conjok2(i,2));
    
    acabar = 0;
    
    % primera posibilidad: dedo fijo en el punto 1
    %---------------------------------------------

    % cuatro comprobaciones por hacer (una por cada punto de contacto mas aperturas iguales)
    ok1 = 0;
    ok2 = 0;
   
    if acabar==0
        
        % vector director hacia dedo 1 desde dedo 2
        dirx = x{c1}(p1)-x{c2}(p2);
        diry = y{c1}(p1)-y{c2}(p2);
        ang = (180/pi)*angle(dirx+j*diry);
    
        % diferencia con el angulo normal en el punto de contacto 1, debe ser menor que un cierto limite
        dif = abs(ang - angulo(conjok2(i,1)));
        if dif<70
            ok1 = 1;           
        end
        
    end
    
        
    if ok1
        
        % vector director hacia dedo 2 desde dedo 1
        dirx = x{c2}(p2)-x{c1}(p1);
        diry = y{c2}(p2)-y{c1}(p1);
        ang = (180/pi)*angle(dirx+j*diry);
    
        % diferencia con el angulo normal en el punto de contacto 2, debe ser menor que un cierto limite
        dif = abs(ang - angulo(conjok2(i,2)));
        if dif<70
            ok2 = 1;           
        end
          
    end
               
    % suma de todas las condiciones 
    if ok1&ok2
        num_ok3 = num_ok3+1;
        conjok3(num_ok3, 1)=conjok2(i,1);
        conjok3(num_ok3, 2)=conjok2(i,2);
        acabar = 1;
    end
    
end

if num_ok3==0
    conjok3=[];
end

% OJO CON NO UTILIZAR J EN LOS BUCLES, SE USA COMO UNIDAD IMAGINARIA