% dibuja resultados para articulo PRL
function results_train_test(objetos)

num = length(objetos);

% lee datos de puntos de contacto
file_train = fopen('../results/train.txt', 'r');
file_test = fopen('../results/test.txt', 'r');
for ii=1:num
    linea = fgets(file_train);
    datos = sscanf(linea(22:length(linea)), '%f');
    x1(ii) = datos(1);
    y1(ii) = datos(2);
    x2(ii) = datos(3);
    y2(ii) = datos(4);
    linea = fgets(file_test);
    if linea(12:19)=='x1y1x2y2'
        solucion(ii)=1;
        datos = sscanf(linea(22:length(linea)), '%f');
        xt1(ii) = datos(1);
        yt1(ii) = datos(2);
        xt2(ii) = datos(3);
        yt2(ii) = datos(4);
    else
        solucion(ii)=0;
    end
end
fclose(file_train);
fclose(file_test);

% prepara plot (en funcin del nmero de imagenes)
if num<5
    filas = 2;
    columnas = 2;
elseif num<10
    filas = 3;
    columnas = 3;
elseif num<17
    filas = 4;
    columnas = 4;
elseif num<19
    filas = 6;
    columnas = 3;
else
    filas = ceil(num/4);
    columnas = 4;
end

lado = 1/filas;

for ii=1:filas
    for jj=1:columnas
            
        n = (ii-1)*columnas+jj;
        if n>num
            break
        end
        
        subplot('position', [lado*(jj-1), lado*(filas-ii), lado*0.975, lado*0.975]);
        % subplot('position', [2*lado*(jj-1), lado*(filas-ii), 2*lado*0.975, lado*0.975]);
            
        % lee figura
        [x, y, xc, yc] = load_object(objetos(n));
			
        % pinta figura rellena
        fill(x{1}-200, y{1}-200, [0.9 0.9 0.9]);
        hold on;
            
        % pinta posibles agujeros
        if length(x)>1
            fill(x{2}-200, y{2}-200, [1 1 1]);
        end
			
        % medidas flechas
        axis equal;
        ejes = axis;
        lf = (ejes(2)-ejes(1))/10; % longitud flecha
        sf = lf/5; % semiancho flecha
            
        % agarre de entrenamiento
        ang = angle(x1(n)-x2(n) + (y1(n)-y2(n))*j);
        flecha1x = [x1(n), x1(n)+lf*cos(ang)-sf*sin(ang), x1(n)+lf*cos(ang)+sf*sin(ang)];
        flecha1y = [y1(n), y1(n)+lf*sin(ang)+sf*cos(ang), y1(n)+lf*sin(ang)-sf*cos(ang)];
        fill(flecha1x, flecha1y, [0.8 1 0.8]);
        flecha2x = [x2(n), x2(n)-lf*cos(ang)+sf*sin(ang), x2(n)-lf*cos(ang)-sf*sin(ang)];
        flecha2y = [y2(n), y2(n)-lf*sin(ang)-sf*cos(ang), y2(n)-lf*sin(ang)+sf*cos(ang)];
        fill(flecha2x, flecha2y, [0.8 1 0.8]);

        % agarre de test
        if solucion(n)
            ang = angle(xt1(n)-xt2(n) + (yt1(n)-yt2(n))*j);
            flecha1x = [xt1(n), xt1(n)+lf*cos(ang)-sf*sin(ang), xt1(n)+lf*cos(ang)+sf*sin(ang)];
            flecha1y = [yt1(n), yt1(n)+lf*sin(ang)+sf*cos(ang), yt1(n)+lf*sin(ang)-sf*cos(ang)];
            fill(flecha1x, flecha1y, [0.8 0 0]);
            flecha2x = [xt2(n), xt2(n)-lf*cos(ang)+sf*sin(ang), xt2(n)-lf*cos(ang)-sf*sin(ang)];
            flecha2y = [yt2(n), yt2(n)-lf*sin(ang)-sf*cos(ang), yt2(n)-lf*sin(ang)+sf*cos(ang)];
            fill(flecha2x, flecha2y, [0.8 0 0]);
        end
            
        % ajusta tamao
        axis equal;
        ejes = axis;
        axis([ejes(1)*1.4, ejes(2)*1.4, ejes(3)*1.4, ejes(4)*1.4]);
        ejes = axis;
        set(gca, 'XTick', []);
        set(gca, 'YTick', []);
        posxtexto = ejes(1)+(ejes(2)-ejes(1))/16;
        posytexto = ejes(3)+(ejes(4)-ejes(3))/16;
        text(posxtexto, posytexto, sprintf('obj.%02d', objetos(n)));
    end
end

hold off;

return


