% reescribe ejemplos de entrenamiento eliminando agarres invalidos
% aleatorios y sustituyendolos por agarres invalidos indicados por
% el usuario
function rewrite_training_examples(objects_selected, ejemplos_mod, modif)
% objects_selected: objetos utilizados en el entrenamiento
% ejemplos_mod: ejemplos de agarres invalidos a aadir
% modif: numero de ejemplos aleatorios ya eliminados

% filenames
filename_loc = '..\\results\\local2.arff';
filename_glo = '..\\results\\global2.arff';
filename_test = '..\\results\test.txt';

% lee el fichero de puntos de contacto
file_test = fopen(filename_test, 'r');
seguir = 1;
while seguir
    linea = fgets(file_test);
    if linea==-1
        seguir = 0;
    else
        figura = sscanf(linea(7:10), '%d');
        datos = sscanf(linea(22:length(linea)), '%f');
        x1(figura) = datos(1);
        y1(figura) = datos(2);
        x2(figura) = datos(3);
        y2(figura) = datos(4);
    end
end
fclose(file_test);

% lee fichero arff local completo
file_loc = fopen(filename_loc, 'r');
num = 0;
seguir = 1;
while seguir
    linea = fgets(file_loc);
    if linea==-1
        seguir=0;
    else
        num = num+1;
        lin_local{num}=linea;
    end
end
fclose(file_loc);
ejemplos_loc = (num-14)/4;

% lee fichero arff global completo
file_glo = fopen(filename_glo, 'r');
num = 0;
seguir = 1;
while seguir
    linea = fgets(file_glo);
    if linea==-1
        seguir=0;
    else
        num = num+1;
        lin_global{num}=linea;
    end
end
fclose(file_glo);
ejemplos_glo = (num-19)/2;

% reescribe fichero arff local modificando las lineas adecuadas
file_loc = fopen(filename_loc, 'w');
% cabecera (14 lineas)
for i=1:14
    fprintf(file_loc, '%s', lin_local{i});
end
% ejemplos ya modificados
for i=1:modif
    fprintf(file_loc, '%s', lin_local{11+4*i});
    fprintf(file_loc, '%s', lin_local{12+4*i});
    fprintf(file_loc, '%s', lin_local{13+4*i});
    fprintf(file_loc, '%s', lin_local{14+4*i});
end    
% ejemplos por modificar
mal_ejemplo = 0;
ini = modif+1;
fin = min(modif+length(ejemplos_mod), ejemplos_loc);
for i=ini:fin
    mal_ejemplo = mal_ejemplo+1;
    fprintf(file_loc, '%s', lin_local{11+4*i});    
    invalido_local(ejemplos_mod(mal_ejemplo), 1, file_loc, x1, y1, x2, y2);
    fprintf(file_loc, '%s', lin_local{13+4*i});    
    invalido_local(ejemplos_mod(mal_ejemplo), 2, file_loc, x1, y1, x2, y2);   
end
% ejemplos por aadir
ini = fin+1;
fin = modif+length(ejemplos_mod);
for i=ini:fin
    mal_ejemplo = mal_ejemplo+1;
    invalido_local(ejemplos_mod(mal_ejemplo), 1, file_loc, x1, y1, x2, y2);
    invalido_local(ejemplos_mod(mal_ejemplo), 2, file_loc, x1, y1, x2, y2);   
end
% ejemplos por mantener igual
ini = fin+1;
fin = ejemplos_loc;
for i=ini:fin
    fprintf(file_loc, '%s', lin_local{11+4*i});
    fprintf(file_loc, '%s', lin_local{12+4*i});
    fprintf(file_loc, '%s', lin_local{13+4*i});
    fprintf(file_loc, '%s', lin_local{14+4*i});
end
fclose(file_loc);

% reescribe fichero arff global modificando las lineas adecuadas
file_glo = fopen(filename_glo, 'w');
% cabecera (19 lineas)
for i=1:19
    fprintf(file_glo, '%s', lin_global{i});
end
% ejemplos ya modificados
for i=1:modif
    fprintf(file_glo, '%s', lin_global{18+2*i});
    fprintf(file_glo, '%s', lin_global{19+2*i});
end    
% ejemplos por modificar
mal_ejemplo = 0;
ini = modif+1;
fin = min(modif+length(ejemplos_mod), ejemplos_glo);
for i=ini:fin
    mal_ejemplo = mal_ejemplo+1;
    fprintf(file_glo, '%s', lin_global{18+2*i});    
    invalido_global(ejemplos_mod(mal_ejemplo), file_glo, x1, y1, x2, y2);
end
% ejemplos por aadir
ini = fin+1;
fin = modif+length(ejemplos_mod);
for i=ini:fin
    mal_ejemplo = mal_ejemplo+1;
    invalido_global(ejemplos_mod(mal_ejemplo), file_glo, x1, y1, x2, y2);
end
% ejemplos por mantener igual
ini = fin+1;
fin = ejemplos_glo;
for i=ini:fin
    fprintf(file_glo, '%s', lin_global{18+2*i});
    fprintf(file_glo, '%s', lin_global{19+2*i});
end
fclose(file_glo);

return


% calcula los parametros locales de un nuevo ejemplo invalido y lo
% escribe en el fichero
function invalido_local(ejemplo_invalido, dedo, fichero, x1, y1, x2, y2)
    
% lee la figura
[x, y, xc, yc] = load_object(ejemplo_invalido);
   
% vuelve a centrar valores aadiendo 200
pointsx = [x1(ejemplo_invalido)+200, x2(ejemplo_invalido)+200];
pointsy = [y1(ejemplo_invalido)+200, y2(ejemplo_invalido)+200];
   
% writes local data for each contact point
writelocal(fichero, 0, x, y, xc, yc, pointsx(dedo), pointsy(dedo), 2);

return

% calcula los parametros globales de un nuevo ejemplo invalido y lo
% escribe en el fichero
function invalido_global(ejemplo_invalido, fichero, x1, y1, x2, y2)
    
% lee la figura
[x, y, xc, yc] = load_object(ejemplo_invalido);
   
% vuelve a centrar valores aadiendo 200
pointsx = [x1(ejemplo_invalido)+200, x2(ejemplo_invalido)+200];
pointsy = [y1(ejemplo_invalido)+200, y2(ejemplo_invalido)+200];
   
% writes global data
writeglobal(fichero, 0, x, y, xc, yc, pointsx, pointsy, 2);
   
return

