% prueba las funciones cinematica_3_dedos y cinematica_scara
% ejemplo==0: ejemplo de puntos alcanzables con apertura cero
% ejemplo<>0: ejemplo de puntos alcanzables con aperturas distintas de cero
function [d1, d2, q1, q2, q3] = robotconfig2(x_obj, y_obj, num, ok, optimo, conjunto)

% para depuracion
imprimir = 0; % hacer igual a uno para mostrar resutlados intermedios

% datos del robot scara
[x_ori, y_ori, la, lb] = datos_scara;

% datos de la pinza de dos dedos
[anch_triang, long_triang, dist_dedo, rec_dedo] = datos_pinza_2;  

% puntos de contacto (x1,y1) (x2,y2)

% numero de contornos y de puntos por contorno
numtotal = 0;
ncont = length(x_obj);
for ii=1:ncont
    npuntos(ii) = length(x_obj{ii});
    for jj=1:npuntos(ii)
        numtotal = numtotal+1;
        c(numtotal)=ii;
        p(numtotal)=jj;
    end        
end

% se buscan los puntos de contacto del conjunto optimo
num_val=0;
for i=1:num
    if ok(i)
        num_val = num_val+1;
        if num_val == optimo
            ind_optimo = i;
        end
    end
end

for i=1:2
    x(i)=x_obj{c(conjunto(ind_optimo,i))}(p(conjunto(ind_optimo,i)));
    y(i)=y_obj{c(conjunto(ind_optimo,i))}(p(conjunto(ind_optimo,i)));
end


% calculo del punto medio de ambos dedos
x_pinza = (x(1)+x(2))/2;
y_pinza = (y(1)+y(2))/2;

% desplazamiento de cada dedo
d1 = sqrt((x(2)-x(1))^2+(y(2)-y(1))^2)/2;
d2 = d1;

% calculo del angulo que forman los dedos
angulo = angle((x(2)-x(1))+(y(2)-y(1))*j);

% alcanzabilidad por el scara

% calcula si el punto es alcanzable
% (basta con comprobar la distancia al origen)
dist_ori = sqrt((x_ori-x_pinza)^2+(y_ori-y_pinza)^2);
            
if dist_ori > la+lb
    
    fprintf(1, 'no alcanzable por scara\n');
    q1 = 0;
    q2 = 0;
    q3 = 0;
    
else
                
    % calcula cinematica si el punto es alcanzable
    [q1, q2, q3] = cinematica_scara(x_ori, y_ori, x_pinza, y_pinza, angulo, la, lb);
    
end

% falta comprobar cual de las dos posibilidades (codo arriba o codo abajo)
% es mas similar a los ejemplos. Copiar del caso de tres dedos



return
    

