% lanza el programa weka de generacion de arboles de decision
function run_weka(ndedos)

% borra los ficheros de resultados previos
file = dir('..\results\local.out');
n = size(file);
if n(1)>0
   delete('..\results\local.out');
end
file = dir('..\results\global.out');
n = size(file);
if n(1)>0
    delete('..\results\global.out');
end

% por compatibilidad con la funcin run_weka_discarding, se crean
% los ficheros localXred.arff y globalXred.arff (X = n de dedos)
if ndedos==3
    copyfile('..\results\local3.arff', '..\results\local3red.arff', 'f');
    copyfile('..\results\global3.arff', '..\results\global3red.arff', 'f');
elseif ndedos==2
    copyfile('..\results\local2.arff', '..\results\local2red.arff', 'f');
    copyfile('..\results\global2.arff', '..\results\global2red.arff', 'f');
end

% lanza el programa
dir_actual = cd();
cd '..\weka'

if ndedos==3
    !java weka.classifiers.lazy.IBk -t ..\results\local3.arff -d ..\results\local3.mod  -x 2 > ..\results\local.out
    !java weka.classifiers.lazy.IBk -t ..\results\global3.arff -d ..\results\global3.mod -x 2 > ..\results\global.out
elseif ndedos==2
    !java weka.classifiers.lazy.IBk -t ..\results\local2.arff -d ..\results\local2.mod -x 2 > ..\results\local.out
    !java weka.classifiers.lazy.IBk -t ..\results\global2.arff -d ..\results\global2.mod -x 2 > ..\results\global.out
end

% comprueba que se han creado los dos arboles de decision necesarios
acabado = 0;
while acabado==0
   file1 = dir('..\results\local.out');
   file2 = dir('..\results\global.out');
   n1 = size(file1);
   n2 = size(file2);
   if n1(1)>0&n2(1)>0
      acabado=1;
   end
end

cd(dir_actual);

return
