% lanza el programa weka de generacion de arboles de decision
function run_weka_discarding(eliminar, total)

% borra los ficheros de resultados previos
file = dir('..\results\local.out');
n = size(file);
if n(1)>0
   delete('..\results\local.out');
end
file = dir('..\results\global.out');
n = size(file);
if n(1)>0
    delete('..\results\global.out');
end

% reescribe los ficheros de datos eliminando ciertas lineas (las que no
% deben utilizarse para entrenar)
reescribe_local_2('../results/local2.arff', '../results/local2red.arff', eliminar, total);
reescribe_global_2('../results/global2.arff', '../results/global2red.arff', eliminar, total);

% lanza el programa
dir_actual = cd();
cd '..\weka'

!java weka.classifiers.lazy.IBk -t ..\results\local2red.arff -d ..\results\local2.mod -x 2 > ..\results\local.out
!java weka.classifiers.lazy.IBk -t ..\results\global2red.arff -d ..\results\global2.mod -x 2 > ..\results\global.out

cd(dir_actual);

% comprueba que se han creado los dos modelos necesarios
acabado = 0;
while acabado==0
   file1 = dir('..\results\local.out');
   file2 = dir('..\results\global.out');
   n1 = size(file1);
   n2 = size(file2);
   if n1(1)>0&n2(1)>0
      acabado=1;
   end
end

% espera a que el usuario pulse una tecla sobre la nueva figura
% figure;
% waitforbuttonpress;

