%%%%%%%%%%%%%%%%%%%%%%%%******%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DIBUJA PINZA DE DOS O TRES DEDOS Y PERMITE SU MOVIMIENTO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%******%%%%%%%%%%%%%%%%%%%%%%
function boton = showresult(ndedos, xobjeto, yobjeto, xcent, ycent, candidato, conjuntos, num_conj, valido, optimo, apertura, desp_1, desp_2, desp_3, q1, q2, q3)

% conversion de valores x,y objeto teniendo en cuenta que hay varios
% contornos
ind = 0;
for ii=1:length(xobjeto)
    for jj=1:length(xobjeto{ii})
        ind = ind+1;
        xob(ind)=xobjeto{ii}(jj);
        yob(ind)=yobjeto{ii}(jj);
    end
end

% para depurar
% fprintf(1, 'datos del robot: q1=%f   q2=%f   q3=%f\n', q1, q2, q3);

% para no grabar video
video = 0;
% para grabar video
% video = 1;
% seq = 0;


%%%%%%%%%%%%%%%%%%%%%%%%
% CREACION NUEVA VENTANA
%%%%%%%%%%%%%%%%%%%%%%%%

color_fondo = [0.6 0.6 0.6];

if ndedos==3
    figNumber=figure('Name','Grasp simulation environment: three fingered gripper', ...
                 'NumberTitle','off', 'Visible','off');
elseif ndedos==2
    figNumber=figure('Name','Grasp simulation environment: two fingered gripper', ...
                 'NumberTitle','off', 'Visible','off');set (figNumber, 'color', color_fondo);
end
         
set (figNumber, 'menubar', 'none');
set (figNumber, 'Position', [200 40 980 980]); % [150 10 720 720]
set (figNumber, 'resize', 'off');
% set (figNumber, 'deletefcn', 'quit');
axes('Units','normalized', 'Position',[0.00 0.00 1.00 1.00], 'Visible','off');

axis equal;
axis([0 400 0 400]);

%%%%%%%%%%%%%%%%%%
% CREACION BOTONES
%%%%%%%%%%%%%%%%%%
       
% SIGUIENTE DATO
labelStr='Next step';
callbackStr='set(gca,''Userdata'',1)';
btnPos=[0.01 0.94 0.19 0.05];
bot_ok=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...      
        'Position',btnPos, ...
        'Enable','off', ...
        'String',labelStr, ...
        'Callback',callbackStr);

           
% SIGUIENTE EJEMPLO
labelStr='Next example';
callbackStr='set(gca,''Userdata'',-1)';
btnPos=[0.01 0.88 0.19 0.05];
bot_ko=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...      
        'Position',btnPos, ...
        'Enable','off', ...
        'String',labelStr, ...
        'Callback',callbackStr);
    
% CERRAR
labelStr='Close';
callbackStr='set(gca,''Userdata'',-2)';
btnPos=[0.01 0.82 0.19 0.05];
bot_end=uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...      
        'Position',btnPos, ...
        'Enable','off', ...
        'String',labelStr, ...
        'Callback',callbackStr);

    
%%%%%%%%%%%%%%%%%%%%%%%
% SE MUESTRA LA VENTANA
%%%%%%%%%%%%%%%%%%%%%%%

set(figNumber,'Visible','on');  
axHndl=gca;
figNumber=gcf;  
set(figNumber,'Backingstore','off');    

set(gca, 'Userdata', '0');



   % SITUACIN INICIAL PINZA
   xp = .22*400;
   yp = .30*400;
   angulo = pi/2;
   
   if ndedos==3
       apert = pi/4;
   end
   
   
   % PUNTOS QUE DEFINEN LOS DEDOS (RESPECTO DE CENTRO DE LA PINZA) Y EL
   % ROBOT SCARA
   
   % carga las medidas de la pinza
   if ndedos==3
       [pa, rec_dedo, pb, da, db] = datos_pinza_3;
   elseif ndedos==2
       [db, da, pa, rec_dedo] = datos_pinza_2;
   end
   
   % carga los datos del robot scara
   [x_ori, y_ori, la, lb] = datos_scara;

   % posicion inicial de los dedos
   
   if ndedos==3
       
       % dedo 1
       xd(1,1:4) = [0, +db/2, -db/2, 0];
       yd(1,1:4) = [pa, pa+da, pa+da, pa];

       % dedo 2
       xd(2,1:4) = [-pb-pa*sin(apert), -pb-pa*sin(apert)-da*sin(apert)+db*cos(apert)/2, -pb-pa*sin(apert)-da*sin(apert)-db*cos(apert)/2, -pb-pa*sin(apert)];
       yd(2,1:4) = [-pa*cos(apert), -pa*cos(apert)-da*cos(apert)-db*sin(apert)/2, -pa*cos(apert)-da*cos(apert)+db*sin(apert)/2, -pa*cos(apert)];

       % dedo 3
       xd(3,1:4) = [pb+pa*sin(apert), pb+pa*sin(apert)+da*sin(apert)-db*cos(apert)/2, pb+pa*sin(apert)+da*sin(apert)+db*cos(apert)/2, pb+pa*sin(apert)];
       yd(3,1:4) = [-pa*cos(apert), -pa*cos(apert)-da*cos(apert)-db*sin(apert)/2, -pa*cos(apert)-da*cos(apert)+db*sin(apert)/2, -pa*cos(apert)];

       % dedos en conjunto sobre un vector x,y
       xy = [xd(1,:) xd(2,:) xd(3,:); yd(1,:) yd(2,:) yd(3,:)];

       % mximo avance posible para cada dedo
       maxd1 = 0.13;
       maxd2 = 0.13;
       maxd3 = 0.13;
       
   elseif ndedos==2
       
       % dedo 1
       xd(1,1:4) = [0, +db/2, -db/2, 0];
       yd(1,1:4) = [pa, pa+da, pa+da, pa];

       % dedo 2
       xd(2,1:4) = [0, +db/2, -db/2, 0];
       yd(2,1:4) = [-pa, -pa-da, -pa-da, -pa];

       % dedos en conjunto sobre un vector x,y
       xy = [xd(1,:) xd(2,:); yd(1,:) yd(2,:)];

       % mximo avance posible para cada dedo
       maxd1 = 0.145;
       maxd2 = 0.145;      
       
   end
   
   % CINEMATICA INICIAL ROBOT SCARA
   [q1_sca, q2_sca, q3_sca] = cinematica_scara(x_ori, y_ori, xp, yp, 0, la, lb);

   
   % DATOS ROBOT SCARA MINIATURA
   escala = 10;
   x_ori_min = 350;  %x_ori_min = 290;
   y_ori_min = 50;
   la_min  = la/escala;
   lb_min = lb/escala;   


   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % DIBUJO DEL OBJETO A AGARRAR
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

   objeto = patch(...
   'FaceColor', [0 0 1]',...
   'LineStyle', '-',...
   'LineWidth', 2,...
   'erase', 'none',...
   'xdata', xobjeto{1},...
   'ydata', yobjeto{1});

   % posible agujero en el objeto
   if length(xobjeto)>1
        agujero = patch(...
        'FaceColor', color_fondo',...
        'LineStyle', '-',...
        'LineWidth', 2,...
        'erase', 'none',...
        'xdata', xobjeto{2},...
        'ydata', yobjeto{2});   
   end

   % se detecta la zona cubierta por el dibujo
   drawnow;
   colorfig = getframe(figNumber);
   sizefig = size(colorfig.cdata);
 
   % se dibuja un crculo para indicar el centroide
   centroide = rectangle('position', [xcent-.015, ycent-.015, .03, .03],...
    'curvature', [1 1],...
	'edgecolor', 'm',...
    'linewidth', 2);     

   %%%%%%%%%%%%%%%%%%%%
   % DIBUJO DE LA PINZA
   %%%%%%%%%%%%%%%%%%%%

   dedo_1 = line(...
    'color', 'g',...
    'LineStyle', '-',...
    'LineWidth', 2,...
    'erase', 'xor',...
    'xdata', xp+xd(1,:),...
    'ydata', yp+yd(1,:));

   dedo_2 = line(...
    'color', 'r',...
    'LineStyle', '-',...
    'LineWidth', 2,...
    'erase', 'xor',...
    'xdata', xp+xd(2,:),...
    'ydata', yp+yd(2,:));

if ndedos==3
    
   dedo_3 = line(...
    'color', 'b',...
    'LineStyle', '-',...
    'LineWidth', 2,...
    'erase', 'xor',...
    'xdata', xp+xd(3,:),...
    'ydata', yp+yd(3,:));

end

   % drawnow;

   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % DIBUJO DEL ROBOT (LA PARTE QUE QUEPA EN LA FIGURA)
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   art_1 = line(...
       'color', 'r',...
       'LineStyle', '-',...
       'Linewidth', 2,...
       'erase', 'xor',...
       'xdata', [x_ori, x_ori + la*cos(q1_sca(1))],...
       'ydata', [y_ori, y_ori + la*sin(q1_sca(1))]);
 
   art_2 = line(...
       'color', 'r',...
       'LineStyle', '-',...
       'Linewidth', 2,...
       'erase', 'xor',...
       'xdata', [x_ori + la*cos(q1_sca(1)), x_ori + la*cos(q1_sca(1)) + lb*cos(q2_sca(1)+q1_sca(1)-pi)],...
       'ydata', [y_ori + la*sin(q1_sca(1)), y_ori + la*sin(q1_sca(1)) + lb*sin(q2_sca(1)+q1_sca(1)-pi)]);

   
   
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % DIBUJO DEL ROBOT EN MINIATURA
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
   recuadro = rectangle(...
        'edgecolor', 'c',...
        'LineStyle', '-',...
        'LineWidth', 2,...
        'erase', 'none',...
        'position', [278 2 120 120],...
        'curvature', [0 0]);
    
   art_1_min = line(...
       'color', 'r',...
       'LineStyle', '-',...
       'Linewidth', 2,...
       'erase', 'xor',...
       'xdata', [x_ori_min, x_ori_min + la_min*cos(q1_sca(1))],...
       'ydata', [y_ori_min, y_ori_min + la_min*sin(q1_sca(1))]);
 
   art_2_min = line(...
       'color', 'r',...
       'LineStyle', '-',...
       'Linewidth', 2,...
       'erase', 'xor',...
       'xdata', [x_ori_min + la_min*cos(q1_sca(1)), x_ori_min + la_min*cos(q1_sca(1)) + lb_min*cos(q2_sca(1)+q1_sca(1)-pi)],...
       'ydata', [y_ori_min + la_min*sin(q1_sca(1)), y_ori_min + la_min*sin(q1_sca(1)) + lb_min*sin(q2_sca(1)+q1_sca(1)-pi)]);
   
   
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      % DIBUJO DEL OBJETO EN MINIATURA
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
      objeto_min = patch(...
       'FaceColor', [0 0 1]',...
       'LineStyle', '-',...
       'LineWidth', 2,...
       'erase', 'none',...
       'xdata', (xobjeto{1}-x_ori)/escala+x_ori_min,...
       'ydata', (yobjeto{1}-y_ori)/escala+y_ori_min);
   
       % posibles agujeros en el objeto
       if length(xobjeto)>1
         agujero_min = patch(...
         'FaceColor', color_fondo',...
         'LineStyle', '-',...
         'LineWidth', 2,...
         'erase', 'none',...
         'xdata', (xobjeto{2}-x_ori)/escala+x_ori_min,...
         'ydata', (yobjeto{2}-y_ori)/escala+y_ori_min);   
       end

   drawnow;
   
   view(2);    

     
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
   % BUCLE HASTA SITUAR ADECUADAMENTE LA PINZA
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
   
   % primer paso: dibujo de los puntos validos (reducidos)
   % -----------------------------------------------------
   
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');
   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
   
   num_punt = length(candidato);
   num_val = 0;
   for i=1:num_punt
       if candidato(i)==1
           num_val = num_val+1;
           
           % marcar_x(num_val) = xob(i);
           % marcar_y(num_val) = yob(i);
           
           % se dibuja un crculo para indicar el punto de contacto
           contacto(i) = rectangle('position', [xob(i)-2, yob(i)-2, 4, 4],...
            'curvature', [1 1],...
        	'edgecolor', 'm',...
            'linewidth', 2);     

               
       if video==1
           seq = seq+1;
           mov(seq) = getframe(gcf);
       end
       

        
       end
   end
   
   % hold on;
   % plot(marcar_x, marcar_y, 'gx');
  
   drawnow;
   

   % segundo paso: se marcan todas las combinaciones alcanzables
   % -----------------------------------------------------------
   
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');
   
   if video==1
       boton=1
   end
   
   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');      
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
   
   trio=line(...
        'color', 'g',...
        'LineStyle', '-',...
        'LineWidth', 0.1,...
        'erase', 'none',...
        'xdata', [],...
        'ydata', []);
   
   if ndedos==3 
       marcar_x = [0 0 0 0];
       marcar_y = [0 0 0 0];
   elseif ndedos==2
       marcar_x = [0 0];
       marcar_y = [0 0];
   end
   
   for i=1:num_conj
       for j=1:ndedos
           marcar_x(j)=xob(conjuntos(i,j));
           marcar_y(j)=yob(conjuntos(i,j));
       end
       if ndedos==3
            marcar_x(4)=marcar_x(1);
            marcar_y(4)=marcar_y(1);
       end
       
       set (trio, 'xdata', marcar_x, 'ydata', marcar_y);
            
       drawnow
       
       % pause(0.01);

              
       if video==1
           seq = seq+1;
           mov(seq) = getframe(gcf);
       end
       

       
   end

   set (trio, 'xdata', [], 'ydata', []);
   drawnow;
   

   % tercer paso: se marcan todas las combinaciones validas
   % ------------------------------------------------------
   
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');

   if video==1
       boton=1
   end
   
   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
   
   set (trio, 'color', 'm');
   set (trio, 'erase', 'none');
   
   for i=1:num_conj
       if valido(i)
           for j=1:ndedos
               marcar_x(j)=xob(conjuntos(i,j));
               marcar_y(j)=yob(conjuntos(i,j));
           end
           if ndedos==3     
               marcar_x(4)=marcar_x(1);
               marcar_y(4)=marcar_y(1);
           end
           
           set (trio, 'xdata', marcar_x, 'ydata', marcar_y);
       
           % plot(marcar_x, marcar_y, 'm-');
       
           drawnow     
        
           % pause(0.01);

           if video==1
               seq = seq+1;
               mov(seq) = getframe(gcf);
           end
        
           
       end
   end
   
   set (trio, 'xdata', [], 'ydata', []);
   drawnow;
   
   
   % cuarto paso: se marca la combinacion elegida
   % --------------------------------------------
   
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');
   
   if video==1
       boton=1
   end
   
   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
     
   % se busca el conjunto optimo
   num_val=0;
   for i=1:num_conj
       if valido(i)
           num_val = num_val+1;
           if num_val == optimo
               ind_optimo = i;
           end
       end
   end
   
   % si no existe solucion se termina directamente
   %----------------------------------------------
   if optimo==0
    
      muestra_error('No solution found', color_fondo);
        
      % espera a que se pulse el boton de acabar o el de nueva pieza
      set(bot_ko, 'Enable', 'on');
      set(bot_end, 'Enable', 'on');
      boton = get(gca, 'Userdata');
      while boton ~= -1 & boton ~= -2
         pause(0.1);
         boton = get(gca, 'Userdata');
      end
      set(bot_ko, 'Enable', 'off');     
      set(bot_end, 'Enable', 'off');     
      close(gcf);

      return 

   end
   
   
   set (trio, 'color', 'g');

   for j=1:ndedos
        marcar_x(j)=xob(conjuntos(ind_optimo,j));
        marcar_y(j)=yob(conjuntos(ind_optimo,j));
   end
   if ndedos==3
       marcar_x(4)=marcar_x(1);
       marcar_y(4)=marcar_y(1);
   end
   
   % plot(marcar_x, marcar_y, 'c-');       
    
   set (trio, 'xdata', marcar_x, 'ydata',marcar_y);
   drawnow;  
 
   if video==1
           seq = seq+1;
           mov(seq) = getframe(gcf);
   end


   % quinto paso: se desplaza la pinza hacia la situacion de agarre
   % --------------------------------------------------------------
  
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');

   if video==1
       boton=1
   end

   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
     
   % posicion final del centro de la pinza
   xp_fin = x_ori + la*cos(q1)+lb*cos(pi-q2-q1);
   yp_fin = y_ori + la*sin(q1)-lb*sin(pi-q2-q1);
   
   
   % se hace un movimiento suave desde la posicion inicial hacia la
   % posicion final
   
   delta_mov = 1;
   
   diff_x = xp_fin-xp;
   diff_y = yp_fin-yp;
   if yp_fin==yp
       delta_x = sign(diff_x)*delta_mov;
       delta_y = 0;
   else
       ratio2 = (diff_x/diff_y)^2;
       delta_x = sign(diff_x)*delta_mov*sqrt(ratio2/(1+ratio2));
       delta_y = sign(diff_y)*delta_mov*sqrt(1/(1+ratio2));
   end
   
   % se acerca la pinza hasta una distancia suficientemente proxima (se
   % mide al cuadrado para evitar calculos)
     
   %set(art_1, 'erase', 'none');
   %set(art_2, 'erase', 'none');
   %set(art_1_min, 'erase', 'none');
   %set(art_2_min, 'erase', 'none');
   
   acabar = 0;
   while acabar==0
       
       dist_pinza = (xp_fin-xp)^2+(yp_fin-yp)^2;
       if dist_pinza > 2
           xp = xp + delta_x;
           yp = yp + delta_y;
       else
           xp = xp_fin;
           yp = yp_fin;
           acabar = 1;
       end
   
      % se redibuja la pinza en la nueva situacin
      
      giro = [cos(angulo-pi/2) -sin(angulo-pi/2); sin(angulo-pi/2) cos(angulo-pi/2)];
      xy_giro = giro*xy;
            
	  set(dedo_1, 'xdata', xp+xy_giro(1,1:4));
	  set(dedo_1, 'ydata', yp+xy_giro(2,1:4));
      
      set(dedo_2, 'xdata', xp+xy_giro(1,5:8));
	  set(dedo_2, 'ydata', yp+xy_giro(2,5:8));
      
      if ndedos==3
    	  set(dedo_3, 'xdata', xp+xy_giro(1,9:12));
          set(dedo_3, 'ydata', yp+xy_giro(2,9:12));
      end
      
      % se redibuja el brazo robot en la nueva situacion
      
      [q1_sca, q2_sca, q3_sca] = cinematica_scara(x_ori, y_ori, xp, yp, 0, la, lb);
      
      set(art_1, 'xdata', [x_ori, x_ori + la*cos(q1_sca(1))]);
      set(art_1, 'ydata', [y_ori, y_ori + la*sin(q1_sca(1))]);
      
      set(art_2, 'xdata', [x_ori + la*cos(q1_sca(1)), x_ori + la*cos(q1_sca(1)) + lb*cos(q2_sca(1)+q1_sca(1)-pi)]);
      set(art_2, 'ydata', [y_ori + la*sin(q1_sca(1)), y_ori + la*sin(q1_sca(1)) + lb*sin(q2_sca(1)+q1_sca(1)-pi)]);
      
      
      % se redibuja el brazo robot en miniatura en la nueva situacion
      
      xp_min = (xp-x_ori)/escala+x_ori_min;
      yp_min = (yp-y_ori)/escala+y_ori_min;
     
      set(art_1_min, 'xdata', [x_ori_min, x_ori_min + la_min*cos(q1_sca(1))]);
      set(art_1_min, 'ydata', [y_ori_min, y_ori_min + la_min*sin(q1_sca(1))]);
      
      set(art_2_min, 'xdata', [x_ori_min + la_min*cos(q1_sca(1)), x_ori_min + la_min*cos(q1_sca(1)) + lb_min*cos(q2_sca(1)+q1_sca(1)-pi)]);
      set(art_2_min, 'ydata', [y_ori_min + la_min*sin(q1_sca(1)), y_ori_min + la_min*sin(q1_sca(1)) + lb_min*sin(q2_sca(1)+q1_sca(1)-pi)]);
 
	  drawnow;
      pause(0.01);
      
      if video==1
           seq = seq+1;
           mov(seq) = getframe(gcf);
      end

      
   end
   
   
   % sexto paso: se gira la pinza hasta el angulo adecuado
   % -----------------------------------------------------
   
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');

   if video==1
       boton=1
   end
   
   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
     
   % tambien se hace un movimiento suave
   angulo_ini = angulo;
   angulo_fin = (q3+q1+q2)-pi;

   %set(dedo_1, 'erase', 'none');
   %set(dedo_2, 'erase', 'none');
   %set(dedo_3, 'erase', 'none');

   
   acabar = 0;
   while acabar==0
       
       dist_pinza = angulo_fin - angulo;
          
       if dist_pinza>pi
          dist_pinza = dist_pinza-2*pi;
       elseif dist_pinza<-pi
          dist_pinza = dist_pinza+2*pi; 
       end
       
       if dist_pinza>pi/2
          dist_pinza = dist_pinza-pi;
       elseif dist_pinza<-pi/2
          dist_pinza = dist_pinza+pi; 
       end

       if abs(dist_pinza) > 0.05
           angulo = angulo + sign(dist_pinza)*0.05;
       else
           angulo = angulo_fin;
           acabar = 1;
       end
   
      % se redibuja la pinza en la nueva situacin
      
      giro = [cos(angulo-pi/2) -sin(angulo-pi/2); sin(angulo-pi/2) cos(angulo-pi/2)];
      xy_giro = giro*xy;
            
	  set(dedo_1, 'xdata', xp+xy_giro(1,1:4));
	  set(dedo_1, 'ydata', yp+xy_giro(2,1:4));
      
      set(dedo_2, 'xdata', xp+xy_giro(1,5:8));
	  set(dedo_2, 'ydata', yp+xy_giro(2,5:8));
      
      if ndedos==3
    	  set(dedo_3, 'xdata', xp+xy_giro(1,9:12));
          set(dedo_3, 'ydata', yp+xy_giro(2,9:12));
      end
      
	  drawnow;
      pause(0.05);
      
      if video==1
           seq = seq+1;
           mov(seq) = getframe(gcf);
      end

      
   end  
   
   % septimo paso: se modifica la apertura hasta el valor correcto
   %--------------------------------------------------------------
   
   if ndedos==3
       
       % espera a que se pulse el boton de continuar
       set(bot_ok, 'Enable', 'on');
       boton = get(gca, 'Userdata');

       if video==1
           boton=1
       end
       
       while boton ~= 1
           pause(0.1);
           boton = get(gca, 'Userdata');
       end
       set(bot_ok, 'Enable', 'off');
       set(gca, 'Userdata', '0');
      
       % tambien se hace un movimiento suave
       apert_ini = apert;
       apert_fin = apertura;
   
       acabar = 0;
       while acabar==0
       
           dist_pinza = apert_fin - apert;
           if abs(dist_pinza) > 0.05
               apert = apert + sign(dist_pinza)*0.05;
           else
               apert = apert_fin;
               acabar = 1;
           end
   
          % se redibuja la pinza en la nueva situacin
      
          % dedo 2
          xd(2,1:4) = [-pb-pa*sin(apert), -pb-pa*sin(apert)-da*sin(apert)+db*cos(apert)/2, -pb-pa*sin(apert)-da*sin(apert)-db*cos(apert)/2, -pb-pa*sin(apert)];
          yd(2,1:4) = [-pa*cos(apert), -pa*cos(apert)-da*cos(apert)-db*sin(apert)/2, -pa*cos(apert)-da*cos(apert)+db*sin(apert)/2, -pa*cos(apert)];

          % dedo 3
          xd(3,1:4) = [pb+pa*sin(apert), pb+pa*sin(apert)+da*sin(apert)-db*cos(apert)/2, pb+pa*sin(apert)+da*sin(apert)+db*cos(apert)/2, pb+pa*sin(apert)];
          yd(3,1:4) = [-pa*cos(apert), -pa*cos(apert)-da*cos(apert)-db*sin(apert)/2, -pa*cos(apert)-da*cos(apert)+db*sin(apert)/2, -pa*cos(apert)];

          % dedos en conjunto sobre un vector x,y
          xy = [xd(1,:) xd(2,:) xd(3,:); yd(1,:) yd(2,:) yd(3,:)];
      
          giro = [cos(angulo-pi/2) -sin(angulo-pi/2); sin(angulo-pi/2) cos(angulo-pi/2)];
          xy_giro = giro*xy;
            
    	  set(dedo_1, 'xdata', xp+xy_giro(1,1:4));
    	  set(dedo_1, 'ydata', yp+xy_giro(2,1:4));
      
          set(dedo_2, 'xdata', xp+xy_giro(1,5:8));
    	  set(dedo_2, 'ydata', yp+xy_giro(2,5:8));
      
    	  set(dedo_3, 'xdata', xp+xy_giro(1,9:12));
          set(dedo_3, 'ydata', yp+xy_giro(2,9:12));
          
    	  drawnow;
          pause(0.05);
          
          if video==1
               seq = seq+1;
               mov(seq) = getframe(gcf);
          end

      
       end
 
   end

   
   % octavo paso: se cierran los dedos
   %----------------------------------
   
   % espera a que se pulse el boton de continuar
   set(bot_ok, 'Enable', 'on');
   boton = get(gca, 'Userdata');

   if video==1
       boton=1
   end
   
   while boton ~= 1
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ok, 'Enable', 'off');
   set(gca, 'Userdata', '0');
      
   % tambien se hacen movimientos suaves
   
   % dedo 1
   %-------
   avance_x = 0;
   avance_y = 0;
   acabar =0;
    
   while acabar==0
         avance_x = avance_x + 1.3*cos(pi+angulo);
         avance_y = avance_y + 1.3*sin(pi+angulo);
         if sqrt(avance_x^2+avance_y^2)<=rec_dedo-desp_1
            set(dedo_1, 'xdata', xp+avance_x+xy_giro(1,1:4));
 	        set(dedo_1, 'ydata', yp+avance_y+xy_giro(2,1:4));
   	        xdedo = get (dedo_1, 'xdata');
			ydedo = get (dedo_1, 'ydata');
            drawnow;
         else
            % se ha alcanzado el limite del recorrido del dedo 1
            acabar=1;
            lim1=1;
         end
         
         if video==1
               seq = seq+1
               mov(seq) = getframe(gcf);
         end

   end
   
   if ndedos==3
   
       % dedo 2
       %-------   
       avance_x = 0;
       avance_y = 0;
       acabar =0;
   
       while acabar==0     
   
             avance_x = avance_x + 1.3*cos(angulo-apert);
             avance_y = avance_y + 1.3*sin(angulo-apert);
             if sqrt(avance_x^2+avance_y^2)<=rec_dedo-desp_2
          	    set(dedo_2, 'xdata', xp+avance_x+xy_giro(1,5:8));
                set(dedo_2, 'ydata', yp+avance_y+xy_giro(2,5:8));
          	    xdedo = get (dedo_2, 'xdata');
    			ydedo = get (dedo_2, 'ydata');
	            drawnow;
             else
                % se ha alcanzado el limite del recorrido del dedo 2
                acabar=1;
             end
         
             if video==1
               seq = seq+1;
               mov(seq) = getframe(gcf);              
             end
           
       end

       % dedo 3
       %-------   
       avance_x = 0;
       avance_y = 0;
       acabar =0;
   
       while acabar==0     
   
         avance_x = avance_x + 1.3*cos(angulo+apert);
         avance_y = avance_y + 1.3*sin(angulo+apert);
         if sqrt(avance_x^2+avance_y^2)<=rec_dedo-desp_3
            set(dedo_3, 'xdata', xp+avance_x+xy_giro(1,9:12));
            set(dedo_3, 'ydata', yp+avance_y+xy_giro(2,9:12));
      	    xdedo = get (dedo_3, 'xdata');
			ydedo = get (dedo_3, 'ydata');
	        drawnow;
         else
            % se ha alcanzado el limite del recorrido del dedo 3
            acabar=1;
            lim3=1;
         end       
         
         if video==1
               seq = seq+1;
               mov(seq) = getframe(gcf);
         end

         
       end
       
   elseif ndedos==2
       
       % dedo 2
       %-------
       avance_x = 0;
       avance_y = 0;
       acabar =0;
   
       while acabar==0
             avance_x = avance_x + 1.3*cos(angulo);
             avance_y = avance_y + 1.3*sin(angulo);
             if sqrt(avance_x^2+avance_y^2)<=rec_dedo-desp_2
                set(dedo_2, 'xdata', xp+avance_x+xy_giro(1,5:8));
 	            set(dedo_2, 'ydata', yp+avance_y+xy_giro(2,5:8));
       	        xdedo = get (dedo_2, 'xdata');
    			ydedo = get (dedo_2, 'ydata');
                drawnow;
             else
                % se ha alcanzado el limite del recorrido del dedo 2
                acabar=1;
                lim2=1;
             end
             
             if video==1
               seq = seq+1;
               mov(seq) = getframe(gcf);
             end

             
       end
       
   end
  
   % se guarda figura como eps
   % print -r600 -depsc agarre.eps
   
   % espera a que se pulse el boton de acabar o el de nueva pieza
   set(bot_ko, 'Enable', 'on');
   set(bot_end, 'Enable', 'on');
   boton = get(gca, 'Userdata');

   if video==1
       boton=-1
   end
   
   while boton ~= -1 & boton ~= -2
       pause(0.1);
       boton = get(gca, 'Userdata');
   end
   set(bot_ko, 'Enable', 'off');
   set(bot_end, 'Enable', 'off');   
   
   close(gcf);

   if video==1
       movie2avi (mov, 'pepe.avi', 'compression', 'Indeo5');
   end

   return
   
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MUESTRA MENSAJES DE ERROR EN PANTALLA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function muestra_error(texto, color_fondo)

aviso = text(250, 360, texto);
set(aviso, 'FontSize', 20);

for i=1:3
    set(aviso, 'Color', 'r');
    pause(0.5);
    drawnow;    
    view(2);   
    set(aviso, 'Color', color_fondo);
    pause(0.5);
    drawnow;
    view(2);   
end    

return