% guarda los datos de un conjunto de puntos de agarre (datos globales) para un ejemplo de entrenamiento (una linea de fichero)
function result = writeglobal(file, ok, x, y, xc, yc, ptosx, ptosy, num_dedos)

% se busca el contorno donde est el punto seleccionado
% y se calcula el elemento coincidente (el mas cercano)
for ded = 1:num_dedos
    dif_min = inf;
    for cont=1:length(x)
        nptos = length(x{cont});
        for i=1:nptos
            dif = (x{cont}(i)-ptosx(ded))^2+(y{cont}(i)-ptosy(ded))^2;
            if dif<dif_min          
                dif_min = dif;
                cont_min(ded) = cont;
                pto_min(ded) = i;
            end
        end
    end
end

% calculo de los datos globales
[dist, ang] = datosconjunto(x, y, xc, yc, cont_min, pto_min, num_dedos);

% distancia al centro de gravedad
fprintf(file, '%f, ', dist);

% angulo a cinco resoluciones para cada dedo
for i=1:num_dedos
    for j=1:5
        fprintf(file, '%f, ', ang(i,j));
    end
end

% agarre correcto o incorrecto
fprintf(file, '%d\n', ok);

   

