% guarda los datos de un punto de agarre (datos locales) para un ejemplo de entrenamiento (una linea de fichero)
function result = writelocal(file, ok, x, y, xc, yc, xp, yp, num_dedos)

% se busca el contorno donde est el punto seleccionado
% y se calcula el elemento coincidente (el mas cercano)
dif_min = inf;
for cont=1:length(x)
    nptos = length(x{cont});
    for i=1:nptos
        dif = (x{cont}(i)-xp)^2+(y{cont}(i)-yp)^2;
        if dif<dif_min          
            dif_min = dif;
            cont_min = cont;
            pto_min = i;
        end
    end
end

% se calculan los datos del punto de agarre
[dist, angulo] = datospunto(x{cont_min}, y{cont_min}, xc, yc, pto_min);

% distancia al centro de gravedad
fprintf(file, '%f, ', dist);

% curvatura a cinco resoluciones
for i=1:5
    fprintf(file, '%f, ', angulo(i));
end

% agarre correcto o incorrecto
fprintf(file, '%d\n', ok);

return
